//+------------------------------------------------------------------+
//|                                               id_name_object.mq5 |
//|                                                2016, Dina Paches |
//|                           https://login.mql5.com/ru/users/dipach |
//+------------------------------------------------------------------+
#property copyright "Dina Paches"
#property link      "https://login.mql5.com/ru/users/dipach"
#property version   "1.01"
#property description "When you click on a graphic object displays its"
#property description "name, creation time, and the type of the object"
#property indicator_chart_window
#property indicator_plots   0

#include <ObjectCreateAndSet.mqh>
/*    .  :
https://www.mql5.com/ru/forum/63951/page2#comment_1908129*/
//#define TEST_PRINT_TWO(x,y)        Print(__LINE__,", ",__FUNCTION__,", ",(#x)," = ",(x),", ",(#y)," = ",(y))
//---
#define INDICATOR_NAME             "id_name_object"
#define QUANT_OBJ_ALL              (9)//     
#define QUANT_OBJ_BUTTON           (3)
#define QUANT_OBJ_EDIT             (3)
#define CONTROLS_GAP_XY            (2)//     XY
#define X_DISTANCE                 (5) 
#define Y_DISTANCE                 (5)  
#define CLR_PANEL                  clrSilver//  
#define CLR_TEXT                   C'39,39,39'//  
#define CLR_TEXT_BACK              C'150,150,150' //   
#define CLR_BORDER                 clrLavender// 
#define CORNER_PANEL               CORNER_RIGHT_UPPER
//---
input int objWidthHeight=20;//The width and height of a single button (to calculate the dimensions of the canvas and other buttons)
input int font_sz=9;//Font size
//---
int flagClick,flagAntivandal,flagResetEventDelete,
obj0WidthHeight,findPrefixObject;
string prefixObj,textDelInd[2],textRestoring,
nameRectLabel,nameButton[QUANT_OBJ_BUTTON],
nameEdit0[QUANT_OBJ_EDIT],nameEdit1[QUANT_OBJ_EDIT],
textEdit0[QUANT_OBJ_EDIT],textEdit1[QUANT_OBJ_EDIT];
datetime timeCreateRectLabel,timeCreateButton[QUANT_OBJ_BUTTON],
timeCreateEdit0[QUANT_OBJ_EDIT],timeCreateEdit1[QUANT_OBJ_EDIT];
uchar textButtUchar[3]={251,225,226};
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
   flagClick=flagAntivandal=flagResetEventDelete=-1;
/*    ,      
       ,     :*/
   for(int i=QUANT_OBJ_EDIT-1;i>=0;i--){textEdit1[i]=" ";}
//+------------------------------------------------------------------+
/*  :*/
   StringConcatenate(prefixObj,INDICATOR_NAME,"_",Symbol(),"_",
                     EnumToString(Period()));
   IndicatorSetString(INDICATOR_SHORTNAME,prefixObj);
//---   
   NameObjectPanel(nameRectLabel,prefixObj,"rl");
   NameObjectPanel(QUANT_OBJ_BUTTON,nameButton,prefixObj,"but");
   NameObjectPanel(QUANT_OBJ_EDIT,nameEdit0,prefixObj,"ed0");
   NameObjectPanel(QUANT_OBJ_EDIT,nameEdit1,prefixObj,"ed1");
//+------------------------------------------------------------------+
/* ,      :*/
   LanguageTerminal();
//+------------------------------------------------------------------+
/*        :*/
   if(objWidthHeight>=20 && objWidthHeight<=300)
     {obj0WidthHeight=objWidthHeight;}
   else if(objWidthHeight>300){obj0WidthHeight=300;}
   else {obj0WidthHeight=20;}
//---     
   PanelCreate();
/*        
,  -  :
(         ,
        )*/
   if(!RevisionCreateTime(QUANT_OBJ_BUTTON-1,timeCreateButton))
     {return(REASON_INITFAILED);}
   if(!RevisionCreateTime(QUANT_OBJ_EDIT,timeCreateEdit0))
     {return(REASON_INITFAILED);}
   if(!RevisionCreateTime(QUANT_OBJ_EDIT,timeCreateEdit1))
     {return(REASON_INITFAILED);}
//---
   flagClick=flagAntivandal=flagResetEventDelete=0;
//---       :
   bool res;
   ChartEventObjectDeleteGet(res);
   if(res!=true)
     {ChartEventObjectDeleteSet(true);}
//--- create timer
   EventSetTimer(8);
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
   flagAntivandal=-1;
   ObjectsDeleteAll(0,prefixObj,0,-1);
   EventKillTimer();
//---  ,   OnInit REASON_INITFAILED.
   if(reason==REASON_INITFAILED)
     {
      ChIndicatorDelete(prefixObj,textDelInd[0],textDelInd[1],0,0);
     }
//---
   ChartRedraw();
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const int begin,
                const double &price[])
  {
//---

//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
//| Timer function                                                   |
//+------------------------------------------------------------------+
void OnTimer()
  {
//---       
   bool res;
   ChartEventObjectDeleteGet(res);
   if(res!=true)
     {ChartEventObjectDeleteSet(true);}
  }
//+------------------------------------------------------------------+
//| ChartEvent function                                              |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
  {
//+------------------------------------------------------------------+
//|                             |
//+------------------------------------------------------------------+ 
   if(id==CHARTEVENT_OBJECT_CLICK)//id = 1
     {
      if(flagClick==0)//      
        {
         string clickedChartObject=sparam;
         findPrefixObject=StringFind(clickedChartObject,prefixObj);
         //---
         if(findPrefixObject==0)
           {
            findPrefixObject=-1;
            //---
            for(int i=1;i>=0;i--)
              {
               if(StringCompare(clickedChartObject,nameButton[i],true)==0)
                 {
                  switch(i)
                    {
                     //---  "":
                     case 1:flagClick=-1;flagAntivandal=-1;
                     MinimizeTable(nameButton,2,textButtUchar,2,
                                   timeCreateButton,obj0WidthHeight);
                     flagClick=1;flagAntivandal=1;return;
                     //---     :
                     case 0:flagClick=-1;flagAntivandal=-1;
                     ChIndicatorDelete(prefixObj,textDelInd[0],textDelInd[1],0,0);
                     return;
                     default:return;
                    }
                 }
              }
           }
         else//      
           {
            SetValuesTable(clickedChartObject);//  
            return;
           }
        }
      //---     "" :
      else if(flagClick==1)
        {
         findPrefixObject=StringFind(sparam,prefixObj);
         if(findPrefixObject==0)
           {
            string clickedChartObject=sparam;
            findPrefixObject=-1;
            //---  "" :
            if(StringCompare(clickedChartObject,nameButton[2],true)==0)
              {
               flagClick=-1;
               flagAntivandal=-1;
               //---        
               ToExpandTheTable(clickedChartObject);
               //---
               flagClick=0;
               flagAntivandal=0;
               //---      :
               flagResetEventDelete=1;
               //---
               return;
              }
           }
         return;
        }
      return;
     }//if(id==CHARTEVENT_OBJECT_CLICK)
//+------------------------------------------------------------------+
//|       Edit       |
//+------------------------------------------------------------------+
   else  if(id==CHARTEVENT_OBJECT_ENDEDIT)//id = 3
     {
      findPrefixObject=StringFind(sparam,prefixObj);
      if(findPrefixObject==0)
        {
         string endEditChartObject=sparam;
         findPrefixObject=-1;
         int comparison=-1;
         //---
         for(int i=QUANT_OBJ_EDIT-1;i>=0;i--)
           {
            if(StringCompare(endEditChartObject,nameEdit1[i],true)==0)
              {
               string textNew=ObjectGetString(0,endEditChartObject,OBJPROP_TEXT);
               comparison=StringCompare(textEdit1[i],textNew,true);
               //---
               if(comparison!=0)
                 {
                  ObSetString(0,nameEdit1[i],OBJPROP_TEXT,textEdit1[i]);
                 }
               //---
               ChartRedraw();
               return;
              }
           }//for(int i=0;i<QUANT_OBJ_EDIT;i++)
         return;
        }//if(findPrefixObject==0)
      return;
     }//if(id==CHARTEVENT_OBJECT_ENDEDIT)
//+------------------------------------------------------------------+
//|             |
//| CHARTEVENT_OBJECT_CHANGE                                         |
//|     (       |
//|  CHART_EVENT_OBJECT_DELETE=true)                         |
//+------------------------------------------------------------------+
   else  if(id==CHARTEVENT_OBJECT_DELETE || id==CHARTEVENT_OBJECT_CHANGE)
     {
      if(flagClick==-1 || flagAntivandal==-1)return;
      else if(flagResetEventDelete>0)
        {
         findPrefixObject=StringFind(sparam,prefixObj);
         if(findPrefixObject==0)
           {
            findPrefixObject=-1;
            flagResetEventDelete=flagResetEventDelete-1;
            return;
           }
         return;
        }
      //--- ,    /:
      else if(flagAntivandal==0 && flagResetEventDelete==0)
        {
         findPrefixObject=StringFind(sparam,prefixObj);
         //---
         if(findPrefixObject==0)
           {
            string chartObject=sparam;
            findPrefixObject=-1;
            int res=-1;
            //--- ,      :
            res=RestoringObjOneAll(chartObject,prefixObj,flagAntivandal,
                                   flagResetEventDelete,nameRectLabel,
                                   timeCreateRectLabel,QUANT_OBJ_ALL);
            //---
            if(res==1){return;}
            //--- ,      :
            res=RestoringObjArrayAll(chartObject,prefixObj,flagAntivandal,
                                     flagResetEventDelete,QUANT_OBJ_BUTTON,
                                     nameButton,timeCreateButton,QUANT_OBJ_ALL);
            //---
            if(res==1){return;}
            //--- ,     (Edit0)  :
            res=RestoringObjArrayAll(chartObject,prefixObj,flagAntivandal,
                                     flagResetEventDelete,QUANT_OBJ_EDIT,
                                     nameEdit0,timeCreateEdit0,QUANT_OBJ_ALL);
            //---
            if(res==1){return;}
            //--- ,     (Edit1)  :
            res=RestoringObjArrayAll(chartObject,prefixObj,flagAntivandal,
                                     flagResetEventDelete,QUANT_OBJ_EDIT,
                                     nameEdit1,timeCreateEdit1,QUANT_OBJ_ALL);
            //---
            return;
           }
        }
      else if(flagAntivandal==1)//      
        {
         string clickedChartObject=sparam;
         if(StringCompare(clickedChartObject,nameButton[2],true)==0)
           {
            flagAntivandal=-1;
            //---    :
            ChIndicatorDelete(prefixObj,textDelInd[0],textDelInd[1],0,0);
            return;
           }
         return;
        }
      return;
     }//else  if(id==CHARTEVENT_OBJECT_DELETE || id==CHARTEVENT_OBJECT_CHANGE)
  }//void OnChartEvent
//+------------------------------------------------------------------+
//|                                  |
//+------------------------------------------------------------------+
void NameObjectPanel(string &name,
                     const string short_name,
                     const string dt)//-
  {
   StringConcatenate(name,prefixObj,"_",dt,"_1");
  }
//+------------------------------------------------------------------+
//|                                  |
//+------------------------------------------------------------------+
void NameObjectPanel(int count,
                     string &array_name[],
                     const string short_name,
                     const string dt)//-
  {
   for(int x=0;x<count;x++)
     {
      StringConcatenate(array_name[x],prefixObj,"_",
                        dt,"0",IntegerToString(x));
     }
  }
//+------------------------------------------------------------------+
//|   ,          |
//| :                                                       |
//+------------------------------------------------------------------+
void LanguageTerminal()
  {
   string language_t=NULL;
   language_t=TerminalInfoString(TERMINAL_LANGUAGE);
//---
   if(language_t=="Russian")
     {
      textEdit0[0]=" :";
      textEdit0[1]=" :";
      textEdit0[2]=" :";
      //---
      textRestoring="   :  ";
      //---
      StringConcatenate(textDelInd[0],"   : \"",
                        prefixObj,"\".  : ");
      StringConcatenate(textDelInd[1],"   : \"",
                        prefixObj,"\".");
     }
   else
     {
      textEdit0[0]="Object name:";
      textEdit0[1]="Time of object creation:";
      textEdit0[2]="Object type:";
      //---
      textRestoring="Notification of the insured event: object ";
      //---
      StringConcatenate(textDelInd[0],"Failed to delete indicator: \"",
                        prefixObj,"\". Error code: ");
      StringConcatenate(textDelInd[1],
                        "Withdrew from chart indicator: \"",
                        prefixObj,"\".");
     }
   return;
  }
//+------------------------------------------------------------------+
//|                                          |
//+------------------------------------------------------------------+
void PanelCreate(const long chart_ID=0,// ID 
                 const int sub_window=0)//  
  {
//---   :
   int widthPanel=(obj0WidthHeight*11)+(CONTROLS_GAP_XY*2);
//---   :
   int heightPanel=(obj0WidthHeight*6)+(CONTROLS_GAP_XY*8);
//---    :
   int x_dist=X_DISTANCE+widthPanel;
//---
   if(ObjectFind(chart_ID,nameRectLabel)<0)//
     {
      RectLabelCreate(chart_ID,nameRectLabel,sub_window,x_dist,
                      Y_DISTANCE,widthPanel,heightPanel,"\n",CLR_PANEL,
                      BORDER_RAISED,CORNER_PANEL,clrNONE,STYLE_SOLID,1,
                      false,false,true);
      //---      :
      CreateTimeGet(chart_ID,nameRectLabel,timeCreateRectLabel);
     }
//---
   x_dist=X_DISTANCE+CONTROLS_GAP_XY;
   int y_dist=Y_DISTANCE+CONTROLS_GAP_XY;
//---
   for(int i=QUANT_OBJ_BUTTON-2;i>=0;i--)
     {
      //---      :
      if(ObjectFind(chart_ID,nameButton[i])<0)
        {
         ButtonCreate(chart_ID,nameButton[i],sub_window,
                      x_dist+(obj0WidthHeight*(i+1)),y_dist,obj0WidthHeight,
                      obj0WidthHeight,CORNER_PANEL,
                      CharToString(textButtUchar[i]),"\n","Wingdings",
                      font_sz+1,CLR_TEXT,CLR_PANEL,clrNONE);
         //---      :
         CreateTimeGet(chart_ID,nameButton[i],timeCreateButton[i]);
        }
     }
//---
   x_dist=X_DISTANCE+widthPanel-CONTROLS_GAP_XY;
   int y_dist_plus=(CONTROLS_GAP_XY*2)+(obj0WidthHeight*2);
//---
   for(int i=QUANT_OBJ_EDIT-1;i>=0;i--)
     {
      //---   :
      if(ObjectFind(chart_ID,nameEdit0[i])<0)
        {
         EditCreate(chart_ID,nameEdit0[i],sub_window,x_dist,
                    y_dist+(y_dist_plus*i),obj0WidthHeight*8,
                    obj0WidthHeight,textEdit0[i],"Arial",font_sz,
                    "\n",ALIGN_CENTER,true,CORNER_RIGHT_UPPER,
                    CLR_TEXT_BACK,CLR_PANEL,CLR_BORDER);
         //---      :
         CreateTimeGet(chart_ID,nameEdit0[i],timeCreateEdit0[i]);
        }
     }
//---
   //x_dist=X_DISTANCE+widthPanel-CONTROLS_GAP_XY;
   y_dist=Y_DISTANCE+obj0WidthHeight+(CONTROLS_GAP_XY*2);
//---
   for(int i=QUANT_OBJ_EDIT-1;i>=0;i--)
     {
      //---      :
      if(ObjectFind(chart_ID,nameEdit1[i])<0)
        {
         EditCreate(chart_ID,nameEdit1[i],sub_window,x_dist,
                    y_dist+(y_dist_plus*i),obj0WidthHeight*11,
                    obj0WidthHeight,textEdit1[i],"Arial",font_sz,
                    "\n",ALIGN_LEFT,true,CORNER_RIGHT_UPPER,
                    CLR_TEXT,CLR_PANEL,CLR_BORDER);
         //---      :
         CreateTimeGet(chart_ID,nameEdit1[i],timeCreateEdit1[i]);
        }
     }
   return;
  }
//+------------------------------------------------------------------+
//|      :                   |
//+------------------------------------------------------------------+
bool RevisionCreateTime(int quant,datetime &time_create[])
  {
   datetime t=0;
   for(int i=quant-1;i>=0;i--)
     {
      t=time_create[i];
      if(t==0)
        {
         Print(LINE_NUMBER,__FUNCTION__,", Error create time: ",
               TimeToString(t,TIME_DATE|TIME_SECONDS));
         return(false);
        }
     }
//---
   return(true);
  }
//+------------------------------------------------------------------+
//|        |
//|  mql5-   ?                          |
//+------------------------------------------------------------------+
//|  :                                                       |
//|  MQL5 /  ,   |
//| /   /                     |
//+------------------------------------------------------------------+
bool ChartEventObjectDeleteGet(bool &result,const long chart_ID=0,
                               const int sub_window=0)
  {
//---      
   long value;
//---   
   ResetLastError();
//---   
   if(!ChartGetInteger(chart_ID,CHART_EVENT_OBJECT_DELETE,sub_window,value))
     {
      //---       ""
      Print(LINE_NUMBER,__FUNCTION__,", Error Code = ",GetLastError());
      return(false);
     }
//---      
   result=value;
//---  
   return(true);
  }
//+------------------------------------------------------------------+
//|  /         |
//|     mql5-       |
//| .                                                         |
//+------------------------------------------------------------------+
//|  MQL5 /  ,   |
//| /   /                     |
//+------------------------------------------------------------------+
bool ChartEventObjectDeleteSet(const bool value,const long chart_ID=0,
                               const int sub_window=0)
  {
//---   
   ResetLastError();
//---   
   if(!ChartSetInteger(chart_ID,CHART_EVENT_OBJECT_DELETE,sub_window,value))
     {
      //---       ""
      Print(LINE_NUMBER,__FUNCTION__,", Error Code = ",GetLastError());
      return(false);
     }
//---  
   return(true);
  }
//+------------------------------------------------------------------+
//| ""                                    |
//+------------------------------------------------------------------+
void MinimizeTable(string &array_name[],
                   int index_name,
                   uchar &array_text[],
                   int index_text,
                   datetime &array_create_time[],
                   int width_height,
                   const long chart_ID=0,
                   const int  sub_window=0,
                   const int type=-1)
  {
   ObjectsDeleteAll(chart_ID,prefixObj,sub_window,type);
//---
   if(ObjectFind(chart_ID,array_name[index_name])<0)
     {
      ButtonCreate(chart_ID,array_name[index_name],0,
                   X_DISTANCE+obj0WidthHeight,Y_DISTANCE,
                   width_height,width_height,CORNER_PANEL,
                   CharToString(array_text[index_text]),
                   INDICATOR_NAME,"Wingdings",font_sz,
                   CLR_TEXT,CLR_PANEL,clrNONE);
      //---
      array_create_time[index_name]=(datetime)ObjectGetInteger(0,
                                     array_name[index_name],
                                     OBJPROP_CREATETIME);
      ChartRedraw();
      return;
     }
   return;
  }
//+------------------------------------------------------------------+
//|                                        |
//+------------------------------------------------------------------+
void ChIndicatorDelete(const string short_name,//  
                       const string &text_0,//     
                       const string &text_1,//   
                       const long  chart_id=0,//  
                       const int   sub_window=-1//  
                       )
  {
   bool res=ChartIndicatorDelete(chart_id,sub_window,short_name);
//---
   if(!res){Print(LINE_NUMBER,text_0,GetLastError());}
   else Print(LINE_NUMBER,text_1);
  }
//+------------------------------------------------------------------+
//|     ,     |
//+------------------------------------------------------------------+
void SetValuesTable(const string name,// 
                    const long chart_ID=0)
  {
   long type=-1;
   datetime create_time=0;
   int res0=-1,res1=-1;
//---    
   if(!ObjectGetInteger(chart_ID,name,OBJPROP_CREATETIME,0,create_time))
     {
      Print(LINE_NUMBER,__FUNCTION__,", Error = ",
            GetLastError());
     }
   else {res0=0;}
//---   
   if(!ObjectGetInteger(chart_ID,name,OBJPROP_TYPE,0,type))
     {
      Print(LINE_NUMBER,__FUNCTION__,", Error = ",
            GetLastError());
     }
   else{res1=0;}
/*     ,   
   :*/
   bool read_only=false;
/*     ,     
 :*/
   if(res0==-1 || res1==-1)//    
     {
      int comparison=-1;
      for(int i=QUANT_OBJ_EDIT-1;i>=0;i--)
        {
         comparison=StringCompare(textEdit1[i]," ",true);
         if(comparison!=0)
           {
            textEdit1[i]=" ";
            read_only=true;
           }
        }
     }
   else//    
     {
      ENUM_OBJECT type_0=(ENUM_OBJECT)type;
      textEdit1[0]=name;
      textEdit1[1]=TimeToString(create_time,TIME_DATE|TIME_SECONDS);
      textEdit1[2]=EnumToString(type_0);
     }
//---
   string text[QUANT_OBJ_EDIT];//    
   for(int i=QUANT_OBJ_EDIT-1;i>=0;i--)
     {
      if(ObjectFind(0,nameEdit1[i])>-1)
        {
         text[i]=ObjectGetString(chart_ID,nameEdit1[i],OBJPROP_TEXT);
        }
      else {text[i]=NULL;}
     }
   int comparison=-1;
//---
   for(int i=QUANT_OBJ_EDIT-1;i>=0;i--)
     {
      if(text[i]!=NULL)
        {
         comparison=StringCompare(textEdit1[i],text[i],true);
         //---
         if(comparison!=0)
           {
            ObSetString(chart_ID,nameEdit1[i],OBJPROP_TEXT,textEdit1[i]);
            ObSetIntegerBool(chart_ID,nameEdit1[i],OBJPROP_READONLY,read_only);
           }
        }
     }
//---
   ChartRedraw();
   return;
  }
//+------------------------------------------------------------------+
//|                              |
//+------------------------------------------------------------------+
void ToExpandTheTable(string &name)
  {
//---
   ObDelete(0,name);
//---
   PanelCreate();
//---
   ChartRedraw();
   return;
  }
//+------------------------------------------------------------------+
//|  ""   OnChartEvent()          |
//+------------------------------------------------------------------+
//| string sparam =  ,   OnChartEvent()        |
//| string prefix_obj =                |
//| int &flag_antivandal =   /    |
//| int &flag_reset =                               |
//| string name =                                          |
//| datetime time_create =                       |
//| int quant_obj_all =      |
//| , >= quant_obj ( -1,   quant_obj)            |
//| const long chart_ID = 0                      |
//| const int sub_window = 0                               |
//| int start_pos=0       .   |
//+------------------------------------------------------------------+
int RestoringObjOneAll(const string sparam,
                       const string prefix_obj,
                       int &flag_antivandal,
                       int &flag_reset,
                       string name,
                       datetime time_create,
                       const int quant_obj_all,
                       const long chart_ID=0,
                       const int sub_window=0,
                       int start_pos=0)
  {
   int res=-1;
   int comparison=-1;
//---
   comparison=StringCompare(sparam,name,true);
//---     :
   if(comparison==0)
     {
      res=1;
      comparison=-1;
      //---    "" :
      Print(LINE_NUMBER,textRestoring,sparam);
      //---
      flag_antivandal=-1;
      flag_reset=quant_obj_all-1;
      //---
      //TEST_PRINT_TWO(sparam,flag_reset);
      //---
      ObDeletePrefixFlag(flag_reset,prefix_obj,chart_ID,sub_window,start_pos);
      //---
      ChartRedraw();
      //---
      ObDelCreateTimeExcept0(time_create,chart_ID,sub_window,-1);
      //---
      PanelCreate();
      //---
      ChartRedraw();
      //---
      flag_antivandal=0;
      //---
      return(res);
     }
   return(res);
  }
//+-------------------------------------------------------------------+
//|  ""   OnChartEvent()           |
//+-------------------------------------------------------------------+
//| string sparam =  ,   OnChartEvent()         |
//| string prefix_obj =                 |
//| int &flag_antivandal =   /     |
//| int &flag_reset =                                |
//| int quant_obj =     ""          |
//|                                                            |
//| string &name[] =   ""                 |
//| datetime &time_create[] =        |
//| int quant_obj_all=-1      |
//| , >= quant_obj ( -1,   quant_obj)             |
//| const long chart_ID = 0                       |
//| const int sub_window = 0                                |
//| int start_pos=0        |
//+-------------------------------------------------------------------+
int RestoringObjArrayAll(const string sparam,
                         const string prefix_obj,
                         int &flag_antivandal,
                         int &flag_reset,
                         const int quant_obj,
                         string &name[],
                         datetime &time_create[],
                         int quant_obj_all=-1,
                         const long chart_ID=0,
                         const int sub_window=0,
                         const int start_pos=0)
  {
//---   :
   int res=-1;
/*        
   .  ,        
     ,      "" 
   .
         
        .*/
   if(quant_obj<=0)//     <= 0
     {
      Print(LINE_NUMBER,__FUNCTION__,
            ", Error Code. Wrong value: quant_obj =",quant_obj);
      return(res);
     }
   else   if(quant_obj>quant_obj_all && quant_obj_all!=-1)
     {
      Print(LINE_NUMBER,__FUNCTION__,
            ", Error Code. Not the correct value: quant_obj_all");
      return(res);
     }
   else if(quant_obj_all==-1){quant_obj_all=quant_obj;}
//---       :
   int comparison=-1;
/*          
  :*/
   for(int i=quant_obj-1;i>=0;i--)
     {
      comparison=StringCompare(sparam,name[i],true);
      //---     :
      if(comparison==0)
        {
         comparison=-1;
         res=1;
         //---    "" :
         Print(LINE_NUMBER,textRestoring,sparam);
/*    ,   
     :*/
         flag_antivandal=-1;
/*  - ,    
   .    
       
    :*/
         flag_reset=quant_obj_all-1;
         //---
         //TEST_PRINT_TWO(sparam,flag_reset);
         //---  ,   ,   
         ObDeletePrefixFlag(flag_reset,prefix_obj,chart_ID,sub_window,start_pos);
         //---  
         ChartRedraw();
         //--- ,   ,  :*/
         ObDelCreateTimeExcept0(time_create[i],chart_ID,sub_window);
         //---  
         PanelCreate();
         //---   
         ChartRedraw();
         //---  
         flag_antivandal=0;
         //---
         return(res);
        }
     }//for(int i=QUANT_OBJECTS-1;i>=0;i--)
   return(res);
  }
//+------------------------------------------------------------------+
//|                                    |
//+------------------------------------------------------------------+
bool CreateTimeGet(const long chart_ID,
                   const string &name,
                   datetime &value
                   )
  {
   datetime res=0;
   if(!ObjectGetInteger(chart_ID,name,OBJPROP_CREATETIME,0,res))
     {
      Print(LINE_NUMBER,__FUNCTION__,", Error = ",
            GetLastError(),", name: ",name);
      return(false);
     }
   value=res;
   return(true);
  }
//+------------------------------------------------------------------+
//|                   |
//|(  ,  ):                              |
//| 2015 ( : 09.09.2015)                           |
//+------------------------------------------------------------------+
//|   :                                            |
//| http://book.mql4.com/ru/functions/strings                        |
//| http://forum.mql4.com/ru/56236/page323#877513                    |
//| http://forum.mql4.com/ru/46980/page423#703533                    |
//+------------------------------------------------------------------+
//| int &flag_reset =            |
//| string prefix_obj =                   |
//| long  chart_ID =                             | 
//| int   sub_window=-1 =   (-1 = )                     |
//| int start_pos=-1 =       |
//|                                                     |
//+------------------------------------------------------------------+
int ObDeletePrefixFlag(int &flag_reset,
                       string prefix_obj,
                       const long chart_ID=0,
                       const int sub_window=0,
                       int start_pos=0)

  {
   int quant_obj=ObjectsTotal(chart_ID,sub_window,-1);
   if(quant_obj>0)
     {
      int count=0;
      int prefix_len=StringLen(prefix_obj);
      string find_substr=NULL,obj_name=NULL;
      //---
      for(int i=quant_obj-1;i>=0;i--)
        {
         obj_name=ObjectName(chart_ID,i,sub_window,-1);
         find_substr=StringSubstr(obj_name,start_pos,prefix_len);

         if(StringCompare(find_substr,prefix_obj,true)==0)
           {
            count=count+1;
            ObDelete(chart_ID,obj_name);
           }
        }
      if(count>0 && flag_reset<count)
        {flag_reset=count;}
     }
   return(flag_reset);
  }
//+------------------------------------------------------------------+
//|                               |
//|   ,  :                               |
//|(      = 0(1970.01.01 00:00:00)|
//| 2015 ( : 09.09.2015), Dina Paches              |
//| https://login.mql5.com/ru/users/dipach                           |
//+------------------------------------------------------------------+
//|      :                     |
//| http://book.mql4.com/ru/functions/strings                        |
//| http://forum.mql4.com/ru/56236/page323#877513                    |
//| http://forum.mql4.com/ru/46980/page423#703533                    |
//+------------------------------------------------------------------+
void ObDelCreateTimeExcept0(datetime &create_time,//  
                            long chart_ID=0,//  
                            int sub_window=-1,//  
                            ENUM_OBJECT type=-1)// -1 =   
  {
/*  ,    = 0(1970.01.01 00:00:00),
       ,    
 ,       
  :*/
   if(create_time==0){return;}
   int quant_obj=0;
   quant_obj=ObjectsTotal(chart_ID,sub_window,type);
//---
   if(quant_obj>0)
     {
      datetime create_time_x=0;
      string obj_name=NULL;
      //---
      for(int i=quant_obj-1;i>=0;i--)
        {
         obj_name=ObjectName(chart_ID,i,sub_window,type);
         create_time_x=(datetime)ObjectGetInteger(chart_ID,
                        obj_name,OBJPROP_CREATETIME);
         //---
         if(create_time_x==create_time)
           {ObDelete(chart_ID,obj_name);}
        }
     }
   return;
  }
//+------------------------------------------------------------------+
